package com.hfkj.dao;

import com.hfkj.entity.BsOrderRefund;
import com.hfkj.entity.BsOrderRefundExample.Criteria;
import com.hfkj.entity.BsOrderRefundExample.Criterion;
import com.hfkj.entity.BsOrderRefundExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsOrderRefundSqlProvider {

    public String countByExample(BsOrderRefundExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_order_refund");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsOrderRefundExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_order_refund");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsOrderRefund record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_order_refund");
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderChildNo() != null) {
            sql.VALUES("order_child_no", "#{orderChildNo,jdbcType=VARCHAR}");
        }
        
        if (record.getUserId() != null) {
            sql.VALUES("user_id", "#{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserPhone() != null) {
            sql.VALUES("user_phone", "#{userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundOrderNo() != null) {
            sql.VALUES("refund_order_no", "#{refundOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAccountMerchantNo() != null) {
            sql.VALUES("account_merchant_no", "#{accountMerchantNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAccountMerchantKey() != null) {
            sql.VALUES("account_merchant_key", "#{accountMerchantKey,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundPayChannel() != null) {
            sql.VALUES("refund_pay_channel", "#{refundPayChannel,jdbcType=INTEGER}");
        }
        
        if (record.getReufndPayType() != null) {
            sql.VALUES("reufnd_pay_type", "#{reufndPayType,jdbcType=INTEGER}");
        }
        
        if (record.getRefundSerialNo() != null) {
            sql.VALUES("refund_serial_no", "#{refundSerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundPayChannelOrderNo() != null) {
            sql.VALUES("refund_pay_channel_order_no", "#{refundPayChannelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundPrice() != null) {
            sql.VALUES("refund_price", "#{refundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getRefundIntegral() != null) {
            sql.VALUES("refund_integral", "#{refundIntegral,jdbcType=BIGINT}");
        }
        
        if (record.getRefundRemark() != null) {
            sql.VALUES("refund_remark", "#{refundRemark,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundStatus() != null) {
            sql.VALUES("refund_status", "#{refundStatus,jdbcType=INTEGER}");
        }
        
        if (record.getRefundFailReason() != null) {
            sql.VALUES("refund_fail_reason", "#{refundFailReason,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.VALUES("finish_time", "#{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpUserType() != null) {
            sql.VALUES("op_user_type", "#{opUserType,jdbcType=INTEGER}");
        }
        
        if (record.getOpUserId() != null) {
            sql.VALUES("op_user_id", "#{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.VALUES("op_user_name", "#{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsOrderRefundExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("mer_id");
        sql.SELECT("order_no");
        sql.SELECT("order_child_no");
        sql.SELECT("user_id");
        sql.SELECT("user_phone");
        sql.SELECT("refund_order_no");
        sql.SELECT("account_merchant_no");
        sql.SELECT("account_merchant_key");
        sql.SELECT("refund_pay_channel");
        sql.SELECT("reufnd_pay_type");
        sql.SELECT("refund_serial_no");
        sql.SELECT("refund_pay_channel_order_no");
        sql.SELECT("refund_price");
        sql.SELECT("refund_integral");
        sql.SELECT("refund_remark");
        sql.SELECT("refund_status");
        sql.SELECT("refund_fail_reason");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("finish_time");
        sql.SELECT("op_user_type");
        sql.SELECT("op_user_id");
        sql.SELECT("op_user_name");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_order_refund");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsOrderRefund record = (BsOrderRefund) parameter.get("record");
        BsOrderRefundExample example = (BsOrderRefundExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_order_refund");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderChildNo() != null) {
            sql.SET("order_child_no = #{record.orderChildNo,jdbcType=VARCHAR}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserPhone() != null) {
            sql.SET("user_phone = #{record.userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundOrderNo() != null) {
            sql.SET("refund_order_no = #{record.refundOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAccountMerchantNo() != null) {
            sql.SET("account_merchant_no = #{record.accountMerchantNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAccountMerchantKey() != null) {
            sql.SET("account_merchant_key = #{record.accountMerchantKey,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundPayChannel() != null) {
            sql.SET("refund_pay_channel = #{record.refundPayChannel,jdbcType=INTEGER}");
        }
        
        if (record.getReufndPayType() != null) {
            sql.SET("reufnd_pay_type = #{record.reufndPayType,jdbcType=INTEGER}");
        }
        
        if (record.getRefundSerialNo() != null) {
            sql.SET("refund_serial_no = #{record.refundSerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundPayChannelOrderNo() != null) {
            sql.SET("refund_pay_channel_order_no = #{record.refundPayChannelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundPrice() != null) {
            sql.SET("refund_price = #{record.refundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getRefundIntegral() != null) {
            sql.SET("refund_integral = #{record.refundIntegral,jdbcType=BIGINT}");
        }
        
        if (record.getRefundRemark() != null) {
            sql.SET("refund_remark = #{record.refundRemark,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundStatus() != null) {
            sql.SET("refund_status = #{record.refundStatus,jdbcType=INTEGER}");
        }
        
        if (record.getRefundFailReason() != null) {
            sql.SET("refund_fail_reason = #{record.refundFailReason,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpUserType() != null) {
            sql.SET("op_user_type = #{record.opUserType,jdbcType=INTEGER}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_refund");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("order_child_no = #{record.orderChildNo,jdbcType=VARCHAR}");
        sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        sql.SET("user_phone = #{record.userPhone,jdbcType=VARCHAR}");
        sql.SET("refund_order_no = #{record.refundOrderNo,jdbcType=VARCHAR}");
        sql.SET("account_merchant_no = #{record.accountMerchantNo,jdbcType=VARCHAR}");
        sql.SET("account_merchant_key = #{record.accountMerchantKey,jdbcType=VARCHAR}");
        sql.SET("refund_pay_channel = #{record.refundPayChannel,jdbcType=INTEGER}");
        sql.SET("reufnd_pay_type = #{record.reufndPayType,jdbcType=INTEGER}");
        sql.SET("refund_serial_no = #{record.refundSerialNo,jdbcType=VARCHAR}");
        sql.SET("refund_pay_channel_order_no = #{record.refundPayChannelOrderNo,jdbcType=VARCHAR}");
        sql.SET("refund_price = #{record.refundPrice,jdbcType=DECIMAL}");
        sql.SET("refund_integral = #{record.refundIntegral,jdbcType=BIGINT}");
        sql.SET("refund_remark = #{record.refundRemark,jdbcType=VARCHAR}");
        sql.SET("refund_status = #{record.refundStatus,jdbcType=INTEGER}");
        sql.SET("refund_fail_reason = #{record.refundFailReason,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("finish_time = #{record.finishTime,jdbcType=TIMESTAMP}");
        sql.SET("op_user_type = #{record.opUserType,jdbcType=INTEGER}");
        sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsOrderRefundExample example = (BsOrderRefundExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsOrderRefund record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_refund");
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderChildNo() != null) {
            sql.SET("order_child_no = #{orderChildNo,jdbcType=VARCHAR}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserPhone() != null) {
            sql.SET("user_phone = #{userPhone,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundOrderNo() != null) {
            sql.SET("refund_order_no = #{refundOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAccountMerchantNo() != null) {
            sql.SET("account_merchant_no = #{accountMerchantNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAccountMerchantKey() != null) {
            sql.SET("account_merchant_key = #{accountMerchantKey,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundPayChannel() != null) {
            sql.SET("refund_pay_channel = #{refundPayChannel,jdbcType=INTEGER}");
        }
        
        if (record.getReufndPayType() != null) {
            sql.SET("reufnd_pay_type = #{reufndPayType,jdbcType=INTEGER}");
        }
        
        if (record.getRefundSerialNo() != null) {
            sql.SET("refund_serial_no = #{refundSerialNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundPayChannelOrderNo() != null) {
            sql.SET("refund_pay_channel_order_no = #{refundPayChannelOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundPrice() != null) {
            sql.SET("refund_price = #{refundPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getRefundIntegral() != null) {
            sql.SET("refund_integral = #{refundIntegral,jdbcType=BIGINT}");
        }
        
        if (record.getRefundRemark() != null) {
            sql.SET("refund_remark = #{refundRemark,jdbcType=VARCHAR}");
        }
        
        if (record.getRefundStatus() != null) {
            sql.SET("refund_status = #{refundStatus,jdbcType=INTEGER}");
        }
        
        if (record.getRefundFailReason() != null) {
            sql.SET("refund_fail_reason = #{refundFailReason,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getFinishTime() != null) {
            sql.SET("finish_time = #{finishTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpUserType() != null) {
            sql.SET("op_user_type = #{opUserType,jdbcType=INTEGER}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsOrderRefundExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}